program MainMenu;

uses
  Vcl.Forms,
  Winapi.Windows,
  System.SysUtils,
  MainMenuForm in '..\Src\MainMenuForm.pas' {FormMainMenu},
  Vcl.CallProcessUnit in '..\Src\Vcl.CallProcessUnit.pas';

{$R *.res}

const
  Mutexname = '____MainMenu';

var
  hMutex: THandle;  // Mutexpnh
begin
  Application.Initialize;
  Application.MainFormOnTaskbar := True;

  hMutex := OpenMutex(MUTEX_ALL_ACCESS, False, Mutexname);
  if hMutex = 0 then
  begin

    hMutex := CreateMutex(nil, False, Mutexname);
    Application.CreateForm(TFormMainMenu, FormMainMenu);
  Application.Run;

  end;
  ReleaseMutex(hMutex);
  CloseHandle(hMutex);

end.
