unit Vcl.CallProcessUnit;

interface

uses
  WinApi.Windows, Vcl.Forms, System.SysUtils, Winapi.ShellApi;


type TCallProc = class
  public
    class constructor Create;
    class destructor Destroy;

    class procedure CallProc(AModalMode:boolean; ACmdString:string );
    class procedure ExeRun( AExeName:string);
    class procedure ExcelOpen(  AHandle: HWND; AXlsPath:string);
    class procedure PdfOpen(  AHandle: HWND; APdfPath:string);
    class procedure FolderOpen(  AHandle: HWND; AFolderPath:string);
    class procedure FileOpen( AHandle: HWND; AFilePath:string);
    class procedure URLOpen(AHandle: HWND; AURL: string);
    class procedure CmdExe( AHandle: HWND; ACmd:string);
    class procedure Open(AHandle: HWND; AVal: string);
  end;


implementation


{ TCallProc }

class constructor TCallProc.Create;
begin

end;

class destructor TCallProc.Destroy;
begin

end;

class procedure TCallProc.CallProc(AModalMode:boolean;    //I҂̏ꍇ True ҂ȂƂFalse
                                   ACmdString:string      //R}hC@tpX
                                  );
var
  ret: Boolean;
  RetCode: dword;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  with StartupInfo do         // \Ԃݒ
  begin
    cb := SizeOf(TStartupInfo);                 // ̍\̂̃TCYw
    wShowWindow := SW_SHOWNORMAL;               // EBhE̕\Ԃw
    dwFlags := STARTF_USESHOWWINDOW  or STARTF_USESIZE or STARTF_USEPOSITION;// LȐݒ荀ڂw
    lpReserved := nil;                          // ȊO̍ڂ
    lpDesktop  := nil;
    lpTitle    := nil;
    cbReserved2 := 0;
    lpReserved2 := nil;
  end;

  ret := CreateProcess(
              nil,                        // st@C
              PChar(ACmdString),              // R}hC
              nil,                        // vZX̃ZLeB
              nil,                        // Xbh̃ZLeB
              False,                      // evZXnhp邩
              CREATE_DEFAULT_ERROR_MODE,  // D揇ʂƃvZX̐쐧
              nil,                        // ϐubNւ̃|C^
              nil,                        // JgfBNg
              StartupInfo,                // EBhȆ
              ProcessInfo                 // VvZX̏󂯎\
          );
  if not ret then                                       // G[`FbN
    raise Exception.Create('sł܂ (' + IntToStr(GetLastError) + ')');

  if AModalMode then
  begin

//    repeat  // I҂
//      Application.ProcessMessages;                      // ̃vZX֏𖾂n
//      GetExitCodeProcess(ProcessInfo.hProcess, RetCode);  // IR[h`FbN
//    until RetCode <> STILL_ACTIVE;
(**)
    //{LCPUׂCɂȂƂ͉L̗p
    while True do  // I҂
    begin
      RetCode := WaitForSingleObject(ProcessInfo.hProcess, 100);
      if RetCode = WAIT_OBJECT_0 then break;
      Application.ProcessMessages;
    end;
(**)
  end;

end;

(*
uses
     ,Winapi.ShellAPI

var
  s : String;
begin
  if IsUserAnAdmin then begin
    //ǗҌŎs
  end else begin
    //ǗҌȊOŎs
    s := Application.Exename;
    ShellExecute(Handle, 'runas', PChar(s), nil, nil, SW_NORMAL);
    Close;
  end;

  https://social.msdn.microsoft.com/Forums/vstudio/ja-JP/a3875517-a227-4882-98cb-8e9268376c95/31649297023277327177384802018412365123912345534892123731242812

end;*)

class procedure TCallProc.ExcelOpen(  AHandle: HWND; AXlsPath:string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+AXlsPath+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.ExeRun( AExeName: string);
var
  ExePath: string;
begin

  ExePath := ExtractFilePath( ParamStr(0) );
  ExePath := IncludeTrailingPathDelimiter(ExePath);
  ExePath := ExePath + AExeName;

  CallProc(False, ExePath);

end;

class procedure TCallProc.FileOpen(AHandle: HWND; AFilePath: string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+AFilePath+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.FolderOpen(  AHandle: HWND; AFolderPath:string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+AFolderPath+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.Open(AHandle: HWND; AVal: string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+AVal+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.PdfOpen(AHandle: HWND; APdfPath: string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+APdfPath+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.URLOpen(AHandle: HWND; AURL: string);
begin

  ShellExecute( AHandle,
                'open',
                PChar('"'+AURL+'"'),
                nil,
                nil,
                SW_SHOWNORMAL
              );

end;

class procedure TCallProc.CmdExe(AHandle: HWND; ACmd: string);
begin

  ShellExecute( AHandle,
                'open',
                'cmd.exe',
                PChar('"'+ACmd+'"'),
                nil,
                SW_HIDE
              );

end;


end.
