unit SubBaseForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TFormSubBase = class(TForm)
    TimerMainMenuCheck: TTimer;
    procedure TimerMainMenuCheckTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }

  protected
    { protected 錾 }

  public
    { Public 錾 }
  end;

var
  FormSubBase: TFormSubBase;

implementation

{$R *.dfm}

procedure TFormSubBase.FormCreate(Sender: TObject);
begin

  TimerMainMenuCheck.Enabled := False;

end;

procedure TFormSubBase.FormShow(Sender: TObject);
begin
//

end;

procedure TFormSubBase.TimerMainMenuCheckTimer(Sender: TObject);
var
  hMutex: THandle;  // Mutexpnh
const
  Mutexname = '____MainMenu';
begin

  hMutex := OpenMutex(MUTEX_ALL_ACCESS, False, Mutexname);
  if hMutex = 0 then
  begin
    Close;
  end;
  ReleaseMutex(hMutex);
  CloseHandle(hMutex);

end;

end.
